# 
# * 9.8 Функция isinstance для проверки типов данных
# 
'''
Подвиг 2. Определите функцию с именем get_add, которая складывает или
два числа или две строки (но не число со строкой) и возвращает
полученный результат. Если сложение не может быть выполнено, то функция
возвращает значение None. Сигнатура функции должна быть, следующей:
def get_add(a, b): ...
Вызывать функцию не нужно, только определить. Также ничего не нужно
выводить на экран.
P. S. Не забудьте про необходимость различения булевых значений
(False, True) от целочисленных.
'''
# def get_add(a: any, b: any):
#     if type(a) in (int, float) and type(b) in (int, float):
#         return a + b
#     return a + b if type(a) == type(b) and type(a) is str else None

'''
Подвиг 3. Определите функцию с именем get_sum, которая принимает на
входе итерируемый объект (список, строку, кортеж, словарь, множество) и
вычисляет сумму только целых чисел, взятых из элементов итерируемого
объекта. Вычисленная сумма возвращается функцией. Если целых чисел нет,
то возвращается 0.
Сигнатура функции должна быть, следующей:
def get_sum(it): ...
Вызывать функцию не нужно, только определить. Также ничего не нужно выводить на экран.
Примеры входного аргумента функции:
get_sum([1,2,3, "a", True, [4, 5], "c", (4, 5)])
get_sum({5, 6, 7, '8', 5, '4'})
get_sum((10, "f", '33', True, 12))
get_sum(['1', True, False, (1, 23)])
P. S. Не забудьте про необходимость различения булевых значений (False, True) от целочисленных.
'''
def get_sum(it):
    return sum(filter(lambda x: type(x) is int, it))

'''
Подвиг 4. Определите функцию с именем get_even_sum, которая принимает на
входе итерируемый объект (список, строку, кортеж, словарь, множество) и
вычисляет сумму только целых четных чисел, взятых из элементов
итерируемого объекта. Результат возвращается функцией. Если целых чисел
нет, то возвращается 0.
Сигнатура функции должна быть, следующей:
def get_even_sum(it): ...
Вызывать функцию не нужно, только определить. Также ничего не нужно
выводить на экран.
P. S. Не забудьте про необходимость различения булевых значений
(False, True) от целочисленных.
'''

def get_even_sum(it):
    return sum(filter(lambda x: type(x) is int and x % 2 == 0, it))

'''
Подвиг 5. Определите функцию с именем get_list_dig, которая возвращает
список только из числовых значений переданной ей коллекции (список или
кортеж).
Сигнатура функции должна быть, следующей:
def get_list_dig(lst): ...
Вызывать функцию не нужно, только определить. Также ничего не нужно
выводить на экран.
P. S. Не забудьте про необходимость различения
'''
def get_list_dig(lst: list) ->list: 
    return list(filter(lambda x: type(x) in (int,float), lst))
